---
title: OES_texture_float
slug: Web/API/OES_texture_float
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>OES_texture_float</strong></code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and exposes floating-point pixel types for textures.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension is only available to {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} contexts. In {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}}, the functionality of this extension is available on the WebGL2 context by default.</p>
</div>

<h2 id="Extended_methods">Extended methods</h2>

<p>This extension extends {{domxref("WebGLRenderingContext.texImage2D()")}} and {{domxref("WebGLRenderingContext.texSubImage2D()")}}:</p>

<ul>
	<li>The <code>type</code> parameter now accepts <code>gl.FLOAT</code>.</li>
	<li>The <code>pixels</code> parameter now accepts an <code>ArrayBufferView</code> of type {{jsxref("Float32Array")}}.</li>
</ul>

<h2 id="Limitation_Linear_filtering">Limitation: Linear filtering</h2>

<p>Linear filtering on floating-point textures is not allowed with this extension. If you set the magnification or minification filter in the {{domxref("WebGLRenderingContext.texParameter()")}} method to one of <code>gl.LINEAR</code>, <code>gl.LINEAR_MIPMAP_NEAREST</code>, <code>gl.NEAREST_MIPMAP_LINEAR</code>, or <code>gl.LINEAR_MIPMAP_LINEAR</code>, and use floating-point textures, the texture will be marked as incomplete.</p>

<p>To use linear filtering on floating-point textures, enable the {{domxref("OES_texture_float_linear")}} extension in addition to this extension.</p>

<h2 id="Floating-point_color_buffers">Floating-point color buffers</h2>

<p>This extension implicitly enables the {{domxref("WEBGL_color_buffer_float")}} extension (if supported), which allows rendering to 32-bit floating-point color buffers.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush:js">var ext = gl.getExtension('OES_texture_float');

var texture = gl.createTexture();
gl.bindTexture(gl.TEXTURE_2D, texture);

gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.FLOAT, image);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('OES_texture_float', "", "OES_texture_float")}}</td>
			<td>{{Spec2('OES_texture_float')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.OES_texture_float")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
	<li>{{domxref("WebGLRenderingContext.texImage2D()")}}</li>
	<li>{{domxref("WebGLRenderingContext.texSubImage2D()")}}</li>
	<li>{{domxref("OES_texture_float_linear")}}</li>
	<li>{{domxref("OES_texture_half_float")}}</li>
	<li>{{domxref("OES_texture_half_float_linear")}}</li>
</ul>
